# Outbound ASN Event Client endpoint to which Outbound ASN is posted to. This endpoint along with any authentication mechanisms needed must be communicated to client's account manager. Endpoint: POST /outbound_asn Version: 1.0.0 ## Request fields (application/json): - `from` (object, required) The location this ASN is being sent from. - `from.identifier` (string) Identifier for the from location. When from.type is warehouse: - If an External Identifier is configured for the warehouse, this will surface that identifier. - If not, this will default to the internal OT warehouse ID. Example: "16" - `from.type` (string) Type of the from location options include [warehouse, store]. This will typically be “warehouse”. Example: "warehouse" - `to` (object, required) The location this ASN is being sent to. - `to.identifier` (string) Identifier for the to location. - When stock transferring, this value is the stock transfer identifier configured in warehouse settings - For freight shipments, this value is the external warehouse identifier configured for the warehouse. - For vendor shipments, this value is a number signifying the internal OptiTurn vendor ID Example: "07" - `to.address` (object) The address this shipment is going to. See below for fields. - `to.address.name` (string, required) The address to name. Example: "Bliss Diamond" - `to.address.company` (string) The address company line (under name) Example: "Acme" - `to.address.street` (string, required) The street address. Example: "6001 N Dr South" - `to.address.street2` (string) An optional second line for the street address, for suite or other similar additions. Example: "60 N Dr North" - `to.address.city` (string, required) The city for this address. Example: "LIBERTYVILLE" - `to.address.state` (string, required) The state for this address. Example: "OH" - `to.address.zip` (string, required) The zip code for this address. Example: "43125" - `asn_number` (string, required) A number generated by Optiturn uniquely identifying this ASN. The regex for this value is: /[A-Za-z0-9-_]{1,255}/. Sometimes Outbound ASNs are split into multiple messages depending on the size of the shipment. In this case each asn_number will be appended by an incremental number, for example: “_1, _2, etc”. Example: "1498456_7417412" - `channel` (string, required) The channel which the inventory is being fulfilled for - e.g. RTV, RTS, Outlet. Example: "active_ret" - `shipment_identifier` (string, required) An identifier for this shipment, representing the Order Number, RA number, or other reference for that shipment. Example: "WS3710296-213344" - `tracking_number` (string) The tracking number or PRO number for containers in the shipment. If there are multiple different PRO numbers we only pass the first one scanned. There is no character limit on this attribute, Optoro will pass what is scanned. For stock transfers this will always be null. Example: "1ZA0000000" - `carrier` (string) The carrier for the shipment. For stock transfers this will always be null. Example: "UPS GROUND" - `carrier_payment_type` (string) How the carrier will be paid for this shipment, one of: “prepaid” or “collect”. For stock transfers this will always be null. Example: "collect" - `ship_date` (string, required) An iso8601 formatted date string representing when the ASN was or will be shipped (YYYY-MM-DDT00:00:00) in UTC. This value can be updated using the update endpoint (below). Example: "2023-08-28T04:49:50.693Z" - `status` (string, required) Allowed values: “pending”, “shipped”, “delivered”, “canceled”. Example: "shipped" - `details_type` (string, required) This will always be “unit”. Example: "unit" - `cartons` (array, required) Each object (carton) below represents a single box or pallet which has been shipped. - `cartons.identifier` (string) The scannable identifier for this carton. Example: "T00028546" - `cartons.reference` (object) Reference to a Stock Transfer Order, Return Authorization, RMA, Forward Order or Returns Portal Order which can be used to reconcile against. See below for fields. - `cartons.reference.type` (string, required) Reference type, allowed values are: StockTransferOrder, RA, RMA, ForwardOrder or ReturnsPortalOrder. Example: "RA" - `cartons.reference.identifier` (string, required) Reference identifier - for example: the RMA number or RA Number associated with this shipment. This is a pass through from the inbound ASN. Example: "573001000000" - `cartons.reference.alternate_identifier` (string) Secondary reference identifier. Example: "742769019332" - `cartons.details` (array, required) The sku or unit lines expected in this carton. See below for details fields. - `cartons.details.line_identifier` (string, required) identifier for this line, unique within this ASN. Example: "1" - `cartons.details.program_identifier` (string, required) Identifies which program the unit was received into. The value will be provided by Optoro during implementation. Example: "16_rma" - `cartons.details.unit_identifier` (string, required) The Optiturn LP for this unit. Example: "A0393197881" - `cartons.details.client_unit_identifier` (string) Client unique Identifier Example: "B04847382" - `cartons.details.inbound_received_asn` (string) Inbound ASN Number associated with the unit at receiving Example: "d470a87c-4f63-4f0e-bc76-4683247bc434" - `cartons.details.sku` (string, required) The SKU for this item Example: "768983020002" - `cartons.details.upc` (string) The UPC for this item Example: "500097771079" - `cartons.details.quantity` (integer, required) Always 1 for now, present to match up with standard ASN fields, but all Optiturn generated ASNs will be unit level. Example: 1 - `cartons.details.vendor_identifier` (string) The identifier for this unit’s vendor or supplier. Example: "Bradtke and Streich" - `cartons.details.serial_number` (string) Serial number for this unit Example: "11" - `cartons.details.condition` (string, required) Condition determined by Optiturn driven warehouse processes. One of N,A,R,B,TT,C,X Enum: "N", "A", "R", "B", "TT", "C", "X" - `cartons.details.eligibility_flags` (array) These are the eligibility flags passed on the inbound ASN and configured in OptiTurn Example: ["64"] - `cartons.details.merchant` (string) Merchant name for the unit Example: "POLO RALPH LAUREN" - `cartons.sorting_template_name` (string) Name of the last assigned directed sorting template to this carton Example: "Disposable Items" - `bol_number` (string) The BOL number on the freight shipment. Example: "21" - `timestamp` (string) iso8601 formatted date string (YYYY-MM-DDT00:00:00) in UTC Example: "2023-08-29T03:41:16.848Z" ## Response 200 fields (application/json): - `message` (string) Example: "Success" ## Response 422 fields (application/json): - `message` (string, required) Summary of the error(s). - `errors` (array, required) Containes one or more error objects. - `errors.field` (string, required) JSON path of the field that failed validation. - `errors.code` (string, required) Categorization of validation failure. Defaults to 'invalid'. Enum: "missing_field", "invalid_type", "invalid" ## Response 400 fields ## Response 401 fields ## Response 500 fields ## Response 502 fields